<template>
    <div class="main-content__div">
      <div class="table-box__div" v-cloak v-loading="loadingFlag">
      <el-form  class="demo-form-inline">
        <el-form-item label="栏目名称">
          <el-input
            placeholder="栏目名称"
            v-model="keyWord"
            style="width:150px;"
            size="small"
            >
          </el-input>
        </el-form-item>
        
        <!-- 搜索按钮 -->
        <el-form-item>
          <el-button type="primary" size="small" @click="searchFrom()">搜索</el-button>
        </el-form-item>
       
      </el-form>
      </div>
      <!-- 列表 -->
      <div class="table-box__div" v-cloak v-loading="loadingFlag">
        <!-- 查询表单 -->
        <el-form :inline="true" class="demo-form-inline">
          <el-form-item>
            <el-button type="primary" size="small" @click="addClick">添加栏目</el-button>
          </el-form-item>
        
        </el-form>
        <el-table
          size="mini"
          :data="tableData"
          :empty-text="tableDataLoadingText"
          style="width: 100%;font-size: 15px;"
          :header-cell-style="{background:'#FAFAFA'}"
        >
          <el-table-column label="编号" width="150" prop="id"></el-table-column>
          <el-table-column label="栏目名称" prop="column_name" width="250"></el-table-column>
          <el-table-column label="父级栏目" prop="parent_column_name" width="200"></el-table-column>
          <el-table-column label="排序" prop="sort" width="200"></el-table-column>
          <el-table-column label="备注" prop="remark" width="200"></el-table-column>
          <el-table-column label="更新时间" prop="updated_at" width="200"></el-table-column>

          <el-table-column   prop="" label="操作" align="center"  fixed="right" width="200">
                  <template v-slot="scope">
                    <div style="display: flex;flex-direction: row;justify-content: center;align-items: center;">
                      <span class="btn"  @click="updateClick(scope.row, scope.$index)">编辑</span>
                      <span class="btn"  @click="deleteAuthority(scope.row,scope.$index)">删除</span>
                    </div>
                  </template>
                </el-table-column>
        </el-table>
        <!-- 分页 -->
        <div class="block" v-show="pagination" style="margin-top: 10px;float: right;">
          <el-pagination
            background
            @current-change="handleCurrentChange"
            :current-page="currentPage"
            :page-size="pageSize"
            layout="total, prev, pager, next, jumper"
            :total="parseInt(tableCount)">
          </el-pagination>
        </div>
      </div>
    </div>
  <Dialog title="温馨提示" content="您确认要删除该栏目吗？"
          @close="DialogShow = false"
          @submitSureClick="submitSureClickDel"
          @DialogFalse="DialogShow = false"
          :innerVisible="DialogShow">
  </Dialog>
  <DialogSlot
      title="添加/编辑"
      @close="websiteColumnDialogShow = false"
      @DialogClose="websiteColumnDialogShow = false"
      :innerVisible="websiteColumnDialogShow"
      @colesClick="websiteColumnDialogShow  = false"
  >
    <editFrom
        @colesClick="websiteColumnDialogShow = false"
        :websiteColumnDataForm="websiteColumnDataForm"
         :isloading="isloading"
        @websiteColumnSubmitClick="websiteColumnSubmitClick"
        @closeDlg="closeDlg"
        >
    </editFrom>
  </DialogSlot>
  </template>
  <script>
  import Dialog from "../../components/dialog";
  import editFrom from "./components/edit";
  import DialogSlot from "../../components/DialogSlot";
  export default {
    components: {
      Dialog,
      editFrom,
      DialogSlot
    },
    data() {
      return {
        value:"1",
        //  站点数据
        tableData: [],
        //  加载中数据提示
        tableDataLoadingText:"拼命加载中······",
        //  是否显示分页
        pagination:false,
        //  每页显示的条数
        pageSize:10,
        //  当前页
        currentPage:1,
        //  菜单列表数据总条数
        tableCount:0,
        keyWord:'',
        loadingFlag: false,
        isShowSource: false, // 是否显示来源列
        id:0,
        DialogShow: false, //控制删除弹窗
        websiteColumnId:'',
        websiteColumnRowIndex:'',
        websiteColumnDataForm: {},
        websiteColumnTableData: [],
        isloading:false, //提交按钮状态
        websiteColumnDialogShow: false, // 控制保存弹窗
      }
    },
    mounted() {},
    methods: {
      // 获取菜单信息列表
      getList:function(){
        let _t = this;
        _t.loadingFlag = true;
        let parames = {
            'page':this.currentPage,
            'pageSize':this.pageSize,
            'keyWord':this.keyWord
        }
        this.$api.website.getWebsiteColumnList(parames).then(res=>{
                _t.loadingFlag = false;
                if(res.code==200){
                  if(res.data.rows.length==0){
                    this.$message.error("没有数据了")
                    return
                  }
                    _t.tableData = res.data.rows;
                    _t.tableCount = res.data.count;
                     //  总条数大于每页显示的条数时显示分页
                    if( _t.tableCount > _t.pageSize ){
                     _t.pagination = true;
                    }
                    if( _t.tableData.length==0 ){
                     _t.tableDataLoadingText = "暂无数据";
                    }
                }else{
                    this.$message.error("查询失败")
                }
            })
      },
      // 点击翻页
      handleCurrentChange(val) {
        this.currentPage = val;
        this.getList();
      },

      addClick(){
        this.websiteColumnDataForm = {}
        this.websiteColumnDialogShow = true
      },
      //更新菜单
      updateClick(row,index){
        console.log(row)
        this.websiteColumnDataForm = row
        this.rowIndex = index
        this.websiteColumnDialogShow = true
      },
      // websiteColumnDialogShow(){
      //   this.isloading = false
      // },
      closeDlg(val){
      
          this.websiteColumnDialogShow = false
          this.isloading = false
      },
      websiteColumnSubmitClick(data){
        let _t = this
        console.log("提交数据",data)
        let parames = data
        _t.isloading = true
        //有id更新，没有新增
        if(parames.id){
          this.$api.website.updateWebsiteColumn(parames).then(res=>{
                _t.loadingFlag = false;
                if(res.code==200){
                  _t.tableData[_t.rowIndex] = parames
                     console.log("修改成功")
                    //  location.reload();
                    this.getList();
                }else{
                    this.$message.error("修改失败")
                }
                this.websiteColumnDialogShow = false
                this.isloading = false
            })
        }else{
          this.$api.website.addWebsiteColumn(parames).then(res=>{
                _t.loadingFlag = false;
                if(res.code==200){
                     console.log("创建成功")
                     this.getList();
                }else{
                    this.$message.error(res.message)
                }
                this.websiteColumnDialogShow = false
                this.isloading = false
            })
        }
       
      },
      //删除菜单
      deleteAuthority(row, index) {
        this.websiteColumnId = row.id
        this.websiteColumnRowIndex = index
        this.DialogShow = true
      },
      submitSureClickDel(row,index){
        let parames = {
          'id':this.websiteColumnId
        }
        this.$api.website.delWebsiteColumn(parames).then(res=>{
          if(res.code==200){
            this.DialogShow = false
            this.tableData.splice(index, 1);
            this.getList()
          }else{
            this.$message.error("删除失败")
          }
        })
      },
      searchFrom(){
        this.currentPage = 1
        this.pageSize = 10
        this.getList()
      }

    },
    created() {
        this.getList();
    }
  }
  </script>
  <style >
   .demo-form-inline{
      display: flex;
   }
   .demo-form-inline .el-form-item{
    margin: 0 20px;
   }
  </style>
  
  